Index: /linux/gdb_bdm
===================================================================
--- /linux/gdb_bdm (revision 182)
+++ /linux/gdb_bdm (revision 270)
@@ -90,5 +90,4 @@
 define drv
 	dv $arg0.ids
-	dv $arg0.sizes
 	dv $arg0.times
 end
Index: /bdm/estim/arx.h
===================================================================
--- /bdm/estim/arx.h (revision 262)
+++ /bdm/estim/arx.h (revision 270)
@@ -17,5 +17,5 @@
 #include "../stat/libEF.h"
 
-namespace bdm{
+namespace bdm {
 
 /*!
@@ -35,4 +35,9 @@
 class ARX: public BMEF {
 protected:
+	//!size of output variable (needed in regressors)
+	int dimx;
+	//!description of modelled data \f$ y_t \f$ in the likelihood function
+	//! Do NOT access directly, only via \c get_yrv().
+	RV _yrv;
 	//! Posterior estimate of \f$\theta,r\f$ in the form of Normal-inverse Wishart density
 	egiw est;
@@ -42,42 +47,63 @@
 	double &nu;
 public:
-	//! Full constructor
-	ARX ( const RV &rv, const mat &V0, const double &nu0, const double frg0=1.0 ) : BMEF ( rv,frg0 ),est ( rv,V0,nu0 ), V ( est._V() ), nu ( est._nu() )
-	{last_lognc=est.lognc();};
+	//! \name Constructors
+	//!@{
+	ARX ( const double frg0=1.0 ) : BMEF ( frg0 ),est (), V ( est._V() ), nu ( est._nu() ) {};
+	ARX ( const ARX &A0 ) : BMEF (),est ( A0.est ), V ( est._V() ), nu ( est._nu() ) {};
+	ARX* _copy_();
+	void set_parameters ( double frg0 ) {frg=frg0;}
+	void set_statistics ( int dimx0, const ldmat V0, double nu0=-1.0 ) {est.set_parameters ( dimx0,V0,nu0 );last_lognc=est.lognc();dimx=dimx0;}
+	//!@}
 
-	//!Copy constructor
-	ARX ( const ARX &A0 ) : BMEF ( A0),est ( rv,A0.V,A0.nu ), V ( est._V() ), nu ( est._nu() ) {};
-
-	//!Auxiliary function
-	ARX* _copy_(bool changerv=false);
-	
 //	//! Set parameters given by moments, \c mu (mean of theta), \c R (mean of R) and \c C (variance of theta)
 //	void set_parameters ( const vec &mu, const mat &R, const mat &C, double dfm){};
 	//! Set sufficient statistics
-	void set_parameters ( const ldmat &V0, const double &nu0 )
-	{est._V() =V0;est._nu() =nu0;last_lognc=est.lognc();}
 	void set_statistics ( const BMEF* BM0 );
-	//! Returns sufficient statistics
-	void get_parameters ( mat &V0, double &nu0 ) {V0=est._V().to_mat(); nu0=est._nu();}
-	//! Here \f$dt = [y_t psi_t] \f$.
+//	//! Returns sufficient statistics
+//	void get_parameters ( mat &V0, double &nu0 ) {V0=est._V().to_mat(); nu0=est._nu();}
+	//!\name Mathematical operations
+	//!@{
+
+	//! Weighted Bayes \f$ dt = [y_t psi_t] \f$.
 	void bayes ( const vec &dt, const double w );
 	void bayes ( const vec &dt ) {bayes ( dt,1.0 );};
-	const epdf& _epdf() const {return est;}
 	double logpred ( const vec &dt ) const;
-	void flatten (const BMEF* B ) {
-		const ARX* A=dynamic_cast<const ARX*>(B);
+	void flatten ( const BMEF* B ) {
+		const ARX* A=dynamic_cast<const ARX*> ( B );
 		// nu should be equal to B.nu
-		est.pow ( A->nu/nu);
-		if(evalll){last_lognc=est.lognc();}
+		est.pow ( A->nu/nu );
+		if ( evalll ) {last_lognc=est.lognc();}
 	}
 	//! Conditioned version of the predictor
-	enorm<ldmat>* predictor(const RV &rv0, const vec &rgr) const; 
-	enorm<ldmat>* predictor(const RV &rv0) const {it_assert_debug(rv0.count()==V.rows()-1,"Regressor is not only 1");return predictor(rv0,vec_1(1.0));}
+	enorm<ldmat>* epredictor ( const vec &rgr ) const;
+	//! Predictor for empty regressor
+	enorm<ldmat>* epredictor() const {it_assert_debug ( est.dimension() ==V.rows()-1,"Regressor is not only 1" );return epredictor ( vec_1 ( 1.0 ) );}
 	//! conditional version of the predictor
-	mlnorm<ldmat>* predictor(const RV &rv0, const RV &rvc0) const;
-	mlstudent* predictor_student(const RV &rv0, const RV &rvc0) const;
+	mlnorm<ldmat>* predictor() const;
+	mlstudent* predictor_student() const;
 	//! Brute force structure estimation.\return indeces of accepted regressors.
 	ivec structure_est ( egiw Eg0 );
+	//!@}
+
+	//!\name Access attributes
+	//!@{
 	const egiw* _e() const {return &est ;};
+	const egiw& _epdf() const {return est;}
+	//!@}
+
+	//!\name Connection
+	//!@{
+	void set_drv ( const RV &drv0 ) {drv=drv0;}
+	RV& get_yrv() {
+		//if yrv is not ready create it
+		if ( _yrv._dsize() !=dimx ) {
+			int i=0;
+			while ( _yrv._dsize() <dimx ) {_yrv.add ( drv ( vec_1(i) ) );i++;}
+		}
+		//yrv should be ready by now
+		it_assert_debug ( _yrv._dsize() ==dimx,"incompatible drv" );
+		return _yrv;
+	}
+	//!@}
 };
 
Index: /bdm/estim/libPF.h
===================================================================
--- /bdm/estim/libPF.h (revision 267)
+++ /bdm/estim/libPF.h (revision 270)
@@ -17,5 +17,5 @@
 #include "../stat/libEF.h"
 
-namespace bdm{
+namespace bdm {
 
 /*!
@@ -36,18 +36,23 @@
 	Array<vec> &_samples;
 	//! Parameter evolution model
-	mpdf &par;
+	mpdf *par;
 	//! Observation model
-	mpdf &obs;
+	mpdf *obs;
 public:
-	//! Default constructor
-	PF ( const RV &rv0, mpdf &par0,  mpdf &obs0, int n0 ) :BM ( rv0 ),
-			n ( n0 ),est ( rv0,n ),_w ( est._w() ),_samples ( est._samples() ),
-			par ( par0 ), obs ( obs0 ) {};
-
+	//! \name Constructors
+	//!@{
+	PF ( ) :est(), _w ( est._w() ),_samples ( est._samples() ) {};
+	PF( mpdf *par0, mpdf *obs0, epdf *epdf0, int n0 ) :
+			est ( ),_w ( est._w() ),_samples ( est._samples() ) 
+			{ par = par0; obs=obs0; est.set_parameters ( ones(n0),epdf0 ); };
+	void set_parameters ( mpdf *par0, mpdf *obs0, int n0 ) 
+			{ par = par0; obs=obs0; n=n0; };
+	void set_statistics (const vec w0, epdf *epdf0){est.set_parameters ( w0,epdf0 );};
+	//!@}
 	//! Set posterior density by sampling from epdf0
 	void set_est ( const epdf &epdf0 );
 	void bayes ( const vec &dt );
 	//!access function
-	vec* __w(){return &_w;}
+	vec* __w() {return &_w;}
 };
 
@@ -71,9 +76,7 @@
 		Array<const epdf*> Coms;
 	public:
-		mpfepdf ( eEmp &E0, const RV &rvc ) :
-				epdf ( RV( ) ), E ( E0 ),  _w ( E._w() ),
+		mpfepdf ( eEmp &E0) :
+				epdf ( ), E ( E0 ),  _w ( E._w() ),
 				Coms ( _w.length() ) {
-			rv.add ( E._rv() );
-			rv.add ( rvc );
 		};
 
@@ -83,5 +86,5 @@
 		vec mean() const {
 			// ugly
-			vec pom=zeros ( ( Coms ( 0 )->_rv() ).count() );
+			vec pom=zeros ( Coms(0)->dimension() );
 			for ( int i=0; i<_w.length(); i++ ) {pom += Coms ( i )->mean() * _w ( i );}
 			return concat ( E.mean(),pom );
@@ -89,10 +92,11 @@
 		vec variance() const {
 			// ugly
-			vec pom=zeros ( ( Coms ( 0 )->_rv() ).count() );
-			vec pom2=zeros ( ( Coms ( 0 )->_rv() ).count() );
+			vec pom=zeros ( Coms ( 0 )->dimension() );
+			vec pom2=zeros (  Coms ( 0 )->dimension() );
 			for ( int i=0; i<_w.length(); i++ ) {
 				pom += Coms ( i )->mean() * _w ( i );
-				pom2 += (Coms ( i )->variance() + pow(Coms(i)->mean(),2)) * _w ( i );}
-			return concat ( E.variance(),pom2-pow(pom,2) );
+				pom2 += ( Coms ( i )->variance() + pow ( Coms ( i )->mean(),2 ) ) * _w ( i );
+			}
+			return concat ( E.variance(),pom2-pow ( pom,2 ) );
 		}
 
@@ -107,8 +111,9 @@
 public:
 	//! Default constructor.
-	MPF ( const RV &rvlin, const RV &rvpf, mpdf &par0, mpdf &obs0, int n, const BM_T &BMcond0 ) : PF ( rvpf ,par0,obs0,n ),jest ( est,rvlin ) {
+	MPF ( mpdf *par0, mpdf *obs0, int n, const BM_T &BMcond0 ) : PF (), jest ( est ) {
+		PF::set_parameters(par0,obs0,n);
 		//
 		//TODO test if rv and BMcond.rv are compatible.
-		rv.add ( rvlin );
+//		rv.add ( rvlin );
 		//
 
@@ -137,5 +142,5 @@
 
 	//!Access function
-	BM* _BM(int i){return Bms[i];}
+	BM* _BM ( int i ) {return Bms[i];}
 };
 
@@ -148,9 +153,9 @@
 	double mlls=-std::numeric_limits<double>::infinity();
 
-	#pragma omp parallel for
-	for ( i=0;i<n;i++ ) {	
+#pragma omp parallel for
+	for ( i=0;i<n;i++ ) {
 		//generate new samples from paramater evolution model;
-		_samples ( i ) = par.samplecond ( _samples ( i ) );
-		llsP ( i ) = par._e()->evallog(_samples(i));
+		_samples ( i ) = par->samplecond ( _samples ( i ) );
+		llsP ( i ) = par->_e()->evallog ( _samples ( i ) );
 		Bms[i]->condition ( _samples ( i ) );
 		Bms[i]->bayes ( dt );
@@ -161,13 +166,14 @@
 	double sum_w=0.0;
 	// compute weights
-	#pragma omp parallel for
+#pragma omp parallel for
 	for ( i=0;i<n;i++ ) {
 		_w ( i ) *= exp ( lls ( i ) - mlls ); // multiply w by likelihood
-		sum_w+=_w(i);
+		sum_w+=_w ( i );
 	}
 
 	if ( sum_w  >0.0 ) {
 		_w /=sum_w; //?
-	} else {
+	}
+	else {
 		cout<<"sum(w)==0"<<endl;
 	}
@@ -179,5 +185,5 @@
 		// Resample Bms!
 
-		#pragma omp parallel for
+#pragma omp parallel for
 		for ( i=0;i<n;i++ ) {
 			if ( ind ( i ) !=i ) {//replace the current Bm by a new one
Index: /bdm/estim/merger.cpp
===================================================================
--- /bdm/estim/merger.cpp (revision 262)
+++ /bdm/estim/merger.cpp (revision 270)
@@ -37,5 +37,5 @@
 	vec &w = eSmp._w(); //aux
 
-	mat Smp_ex =ones ( rv.count() +1,Ns ); // Extended samples for the ARX model - the last row is ones
+	mat Smp_ex =ones ( dim +1,Ns ); // Extended samples for the ARX model - the last row is ones
 	for ( int i=0;i<Ns;i++ ) {	set_col_part ( Smp_ex,i,Smp ( i ) );}
 
@@ -50,7 +50,7 @@
 
 	// Initial component in the mixture model
-	mat V0=1e-8*eye ( rv.count() +1 );
-	ARX A0 ( RV ( "{th_r  }", vec_1 ( rv.count() * ( rv.count() +1 ) ) ),\
-	         V0, rv.count() *rv.count() +5.0 ); //initial guess of Mix: zero mean, large variance
+	mat V0=1e-8*eye ( dim +1 );
+	ARX A0;	
+	A0.set_statistics(dim, V0, dim*dim +5.0 ); //initial guess of Mix: zero mean, large variance
 
 	Mix.init ( &A0, Smp_ex, Nc );
@@ -63,5 +63,5 @@
 	char str[100];
 
-	epdf* Mpred=Mix.predictor ( rv );
+	epdf* Mpred=Mix.epredictor (  );
 	vec Mix_pdf ( Ns );
 	while ( !converged ) {
@@ -71,5 +71,5 @@
 		Mix.bayesB ( Smp_ex, w*Ns );
 		delete Mpred;
-		Mpred = Mix.predictor ( rv ); // Allocation => must be deleted at the end!!
+		Mpred = Mix.epredictor ( ); // Allocation => must be deleted at the end!!
 
 		// This will be active only later in iterations!!!
@@ -102,5 +102,5 @@
 			//======== Same RVs ===========
 			//Split according to dependency in rvs
-			if ( mpdfs ( i )->_rv().count() ==rv.count() ) {
+			if ( mpdfs ( i )->dimension() ==dim ) {
 				// no need for conditioning or marginalization
 				for ( int j=0;j<Ns; j++ ) { // Smp is Array<> => for cycle
@@ -110,5 +110,5 @@
 			else {
 				// compute likelihood of marginal on the conditional variable
-				if ( mpdfs ( i )->_rvc().count() >0 ) {
+				if ( mpdfs ( i )->dimensionc() >0 ) {
 					// Make marginal on rvc_i
 					epdf* tmp_marg = Mpred->marginal ( mpdfs ( i )->_rvc() );
@@ -125,5 +125,5 @@
 				}
 				// Compute likelihood of the missing variable
-				if ( rv.count() > ( mpdfs ( i )->_rv().count() + mpdfs ( i )->_rvc().count() ) ) {
+				if ( dim > ( mpdfs ( i )->dimension() + mpdfs ( i )->dimensionc() ) ) {
 					///////////////
 					// There are variales unknown to mpdfs(i) : rvzs
@@ -134,5 +134,5 @@
 						lw_src ( k ) += log (
 						                    tmp_cond->evallogcond (
-						                        zdls ( i )->get_val ( Smp ( k ) ),
+						                        zdls ( i )->pushdown ( Smp ( k ) ),
 						                        zdls ( i )->get_cond ( Smp ( k ) ) ) );
 						if ( !std::isfinite ( lw_src ( k ) ) ) {
@@ -145,5 +145,5 @@
 				for ( int k= 0; k<Ns; k++ ) {
 					mpdfs ( i )->condition ( dls ( i )->get_cond ( Smp ( k ) ) );
-					lw_src ( k ) += mpdfs ( i )->_epdf().evallog ( dls ( i )->get_val ( Smp ( k ) ) );
+					lw_src ( k ) += mpdfs ( i )->_epdf().evallog ( dls ( i )->pushdown ( Smp ( k ) ) );
 				}
 
Index: /bdm/estim/merger.h
===================================================================
--- /bdm/estim/merger.h (revision 262)
+++ /bdm/estim/merger.h (revision 270)
@@ -49,6 +49,6 @@
 //!Default constructor
 	merger ( const Array<mpdf*> &S ) :
-			compositepdf ( S ), epdf ( getrv ( false ) ),
-			Mix ( Array<BMEF*> ( 0 ),vec ( 0 ) ), dls ( n ), rvzs ( n ), zdls ( n ), eSmp(rv,0) {
+			compositepdf ( S ), epdf ( ),
+			Mix ( Array<BMEF*> ( 0 ),vec ( 0 ) ), dls ( n ), rvzs ( n ), zdls ( n ), eSmp() {
 		RV ztmp;
 		// Extend rv by rvc!
@@ -96,5 +96,5 @@
 		const Vec<double> &w = eSmp._w();
 		const Array<vec> &S = eSmp._samples();
-		vec tmp=zeros ( rv.count() ); 
+		vec tmp=zeros ( dim); 
 		for ( int i=0; i<Ns; i++ ) {
 			tmp+=w ( i ) *S ( i );
@@ -110,5 +110,5 @@
 		cout << sum(w) << "," << w*w <<endl;
 		
-		mat Tmp=zeros(rv.count(), rv.count());
+		mat Tmp=zeros(dim, dim);
 		for ( int i=0; i<Ns; i++ ) {
 			Tmp+=w ( i ) *outer_product(S ( i ), S(i));
@@ -120,5 +120,5 @@
 		const Array<vec> &S = eSmp._samples();
 		
-		vec tmp=zeros(rv.count());
+		vec tmp=zeros(dim);
 		for ( int i=0; i<Ns; i++ ) {
 			tmp+=w ( i ) *pow(S ( i ),2);
Index: /bdm/estim/libKF.cpp
===================================================================
--- /bdm/estim/libKF.cpp (revision 262)
+++ /bdm/estim/libKF.cpp (revision 270)
@@ -62,5 +62,5 @@
 
  /////////////////////////////// EKFS
-EKFfull::EKFfull ( RV rvx0, RV rvy0, RV rvu0 ) : BM ( rvx0 ),E(rvx0) {};
+EKFfull::EKFfull ( ) : BM (),E() {};
 
 void EKFfull::set_parameters ( diffbifn* pfxu0,  diffbifn* phxu0,const mat Q0,const mat R0 ) {
@@ -68,5 +68,5 @@
 	phxu = phxu0;
 
-	dimx = rv.count();
+	dimx = pfxu0->_dimx();
 	dimy = phxu0->_dimy();
 	dimu = pfxu0->_dimu();
@@ -163,5 +163,5 @@
 
 
-EKFCh::EKFCh ( RV rvx0, RV rvy0, RV rvu0 ) : KalmanCh ( rvx0,rvy0,rvu0 ) {}
+EKFCh::EKFCh ( ) : KalmanCh (  ) {}
 
 void EKFCh::set_parameters ( diffbifn* pfxu0,  diffbifn* phxu0,const chmat Q0,const chmat R0 ) {
@@ -241,5 +241,5 @@
 
 void KFcondQR::condition ( const vec &QR ) {
-	it_assert_debug ( QR.length() == ( rvc.count() ),"KFcondRQ: conditioning by incompatible vector" );
+	it_assert_debug ( QR.length() == ( dimx+dimy ),"KFcondRQ: conditioning by incompatible vector" );
 
 	Q.setD ( QR ( 0, dimx-1 ) );
@@ -248,5 +248,5 @@
 
 void KFcondR::condition ( const vec &R0 ) {
-	it_assert_debug ( R0.length() == ( rvc.count() ),"KFcondR: conditioning by incompatible vector" );
+	it_assert_debug ( R0.length() == ( dimy ),"KFcondR: conditioning by incompatible vector" );
 
 	R.setD ( R0 );
Index: /bdm/estim/mixef.cpp
===================================================================
--- /bdm/estim/mixef.cpp (revision 254)
+++ /bdm/estim/mixef.cpp (revision 270)
@@ -132,9 +132,9 @@
 }
 
-emix* MixEF::predictor ( const RV &rv ) const {
+emix* MixEF::epredictor (  ) const {
 	Array<epdf*> pC ( n );
-	for ( int i=0;i<n;i++ ) {pC ( i ) =Coms ( i )->predictor ( rv );}
+	for ( int i=0;i<n;i++ ) {pC ( i ) =Coms ( i )->epredictor ( );}
 	emix* tmp;
-	tmp = new emix ( rv );
+	tmp = new emix (  );
 	tmp->set_parameters ( weights._epdf().mean(), pC, false );
 	tmp->ownComs();
Index: /bdm/estim/arx.cpp
===================================================================
--- /bdm/estim/arx.cpp (revision 254)
+++ /bdm/estim/arx.cpp (revision 270)
@@ -1,5 +1,5 @@
 #include "arx.h"
 
-namespace bdm{
+namespace bdm {
 
 void ARX::bayes ( const vec &dt, const double w ) {
@@ -44,7 +44,6 @@
 }
 
-ARX* ARX::_copy_ ( bool changerv ) {
+ARX* ARX::_copy_ ( ) {
 	ARX* Tmp=new ARX ( *this );
-	if ( changerv ) {Tmp->rv.newids(); Tmp->est._renewrv ( Tmp->rv );}
 	return Tmp;
 }
@@ -54,12 +53,17 @@
 
 	it_assert_debug ( V.rows() ==A0->V.rows(),"ARX::set_statistics Statistics  differ" );
-	set_parameters ( A0->V,A0->nu );
+	set_statistics ( A0->dimx, A0->V, A0->nu );
 }
 
-enorm<ldmat>* ARX::predictor ( const RV &rv, const vec &rgr ) const {
-	mat mu ( rv.count(), V.rows()-rv.count() );
-	mat R ( rv.count(),rv.count() );
+enorm<ldmat>* ARX::epredictor ( const vec &rgr ) const {
+	int dim=est.dimension();
+	mat mu ( dim, V.rows()-dim );
+	mat R ( dim,dim );
+
 	enorm<ldmat>* tmp;
-	tmp=new enorm<ldmat> ( rv );
+	tmp=new enorm<ldmat> ( );
+	//TODO: too hackish
+	if ( drv._dsize() >0 ) {
+	}
 
 	est.mean_mat ( mu,R ); //mu =
@@ -71,12 +75,13 @@
 }
 
-mlnorm<ldmat>* ARX::predictor ( const RV &rv, const RV &rvc ) const {
-	int dif=V.rows() - rv.count() - rvc.count();
+mlnorm<ldmat>* ARX::predictor ( ) const {
+	int dim=est.dimension();
+	int dif=V.rows() - dim ;///<----------- TODO
 	it_assert_debug ( ( dif==0 ) || ( dif==1 ), "Give RVs do not match" );
 
-	mat mu ( rv.count(), V.rows()-rv.count() );
-	mat R ( rv.count(),rv.count() );
+	mat mu ( dim, V.rows()-dim );
+	mat R ( dim,dim );
 	mlnorm<ldmat>* tmp;
-	tmp=new mlnorm<ldmat> ( rv,rvc );
+	tmp=new mlnorm<ldmat> ( );
 
 	est.mean_mat ( mu,R ); //mu =
@@ -85,26 +90,27 @@
 
 	if ( dif==0 ) { // no constant term
-		tmp->set_parameters ( mu, zeros ( rv.count() ), ldmat ( R ) );
+		tmp->set_parameters ( mu, zeros ( dim ), ldmat ( R ) );
 	}
 	else {
 		//Assume the constant term is the last one:
-		tmp->set_parameters ( mu.get_cols (0,mu.cols()-2 ), mu.get_col ( mu.cols()-1 ), ldmat ( R ) );
+		tmp->set_parameters ( mu.get_cols ( 0,mu.cols()-2 ), mu.get_col ( mu.cols()-1 ), ldmat ( R ) );
 	}
 	return tmp;
 }
 
-mlstudent* ARX::predictor_student ( const RV &rv, const RV &rvc ) const {
-	int dif=V.rows() - rv.count() - rvc.count();
+mlstudent* ARX::predictor_student ( ) const {
+	int dim = est.dimension();
+	int dif=V.rows() - est.dimension();//-------------TODO
 	it_assert_debug ( ( dif==0 ) || ( dif==1 ), "Give RVs do not match" );
 
-	mat mu ( rv.count(), V.rows()-rv.count() );
-	mat R ( rv.count(),rv.count() );
+	mat mu ( dim, V.rows()-dim );
+	mat R ( dim,dim );
 	mlstudent* tmp;
-	tmp=new mlstudent ( rv,rvc );
+	tmp=new mlstudent ( );
 
 	est.mean_mat ( mu,R ); //
 	mu = mu.T();
-	
-	int xdim = rv.count();
+
+	int xdim = dimx;
 	int end = V._L().rows()-1;
 	ldmat Lam ( V._L() ( xdim,end,xdim,end ), V._D() ( xdim,end ) );  //exp val of R
@@ -112,9 +118,14 @@
 
 	if ( dif==0 ) { // no constant term
-		tmp->set_parameters ( mu, zeros ( rv.count() ), ldmat ( R ), Lam);
+		tmp->set_parameters ( mu, zeros ( xdim ), ldmat ( R ), Lam );
 	}
 	else {
 		//Assume the constant term is the last one:
-		tmp->set_parameters ( mu.get_cols (0,mu.cols()-2 ), mu.get_col ( mu.cols()-1 ), ldmat ( R ), Lam);
+		if ( mu.cols() >1 ) {
+			tmp->set_parameters ( mu.get_cols ( 0,mu.cols()-2 ), mu.get_col ( mu.cols()-1 ), ldmat ( R ), Lam );
+		}
+		else {
+			tmp->set_parameters ( mat(dim,0), mu.get_col ( mu.cols()-1 ), ldmat ( R ), Lam );
+		}
 	}
 	return tmp;
@@ -178,5 +189,5 @@
 
 ivec ARX::structure_est ( egiw est0 ) {
-	ivec ind=linspace ( 1,rv.count()-1 );
+	ivec ind=linspace ( 1,est.dimension()-1 );
 	egiw_bestbelow ( est, est0, est.lognc()- est0.lognc(), ind );
 	return ind;
Index: /bdm/estim/libKF.h
===================================================================
--- /bdm/estim/libKF.h (revision 262)
+++ /bdm/estim/libKF.h (revision 270)
@@ -105,5 +105,5 @@
 public:
 	//! Default constructor
-	Kalman ( RV rvx0, RV rvy0, RV rvu0 );
+	Kalman ( );
 	//! Copy constructor
 	Kalman ( const Kalman<sq_T> &K0 );
@@ -140,5 +140,5 @@
 public:
 	//! Default constructor
-	KalmanCh ( RV rvx0, RV rvy0, RV rvu0 ):Kalman<chmat>(rvx0,rvy0,rvu0),preA(dimy+dimx+dimx,dimy+dimx),postA(dimy+dimx,dimy+dimx){};
+	KalmanCh ():Kalman<chmat>(),preA(),postA(){};
 	//! Set parameters with check of relevance
 	void set_parameters ( const mat &A0,const mat &B0,const mat &C0,const mat &D0,const chmat &R0,const chmat &Q0 );
@@ -179,5 +179,5 @@
 public:
 	//! Default constructor
-	EKFfull ( RV rvx, RV rvy, RV rvu );
+	EKFfull ( );
 	//! Set nonlinear functions for mean values and covariance matrices.
 	void set_parameters ( diffbifn* pfxu, diffbifn* phxu, const mat Q0, const mat R0 );
@@ -226,5 +226,5 @@
 public:
 	//! Default constructor
-	EKFCh ( RV rvx, RV rvy, RV rvu );
+	EKFCh ();
 	//! Set nonlinear functions for mean values and covariance matrices.
 	void set_parameters ( diffbifn* pfxu, diffbifn* phxu, const chmat Q0, const chmat R0 );
@@ -241,5 +241,5 @@
 public:
 	//!Default constructor
-	KFcondQR ( RV rvx, RV rvy, RV rvu, RV rvRQ ) : Kalman<ldmat> ( rvx, rvy,rvu ),BMcond ( rvRQ ) {};
+	KFcondQR ( ) : Kalman<ldmat> ( ),BMcond ( ) {};
 
 	void condition ( const vec &RQ );
@@ -254,5 +254,5 @@
 public:
 	//!Default constructor
-	KFcondR ( RV rvx, RV rvy, RV rvu, RV rvR ) : Kalman<ldmat> ( rvx, rvy,rvu ),BMcond ( rvR ) {};
+	KFcondR ( ) : Kalman<ldmat> ( ),BMcond ( ) {};
 
 	void condition ( const vec &R );
@@ -262,26 +262,20 @@
 
 template<class sq_T>
-Kalman<sq_T>::Kalman ( const Kalman<sq_T> &K0 ) : BM ( K0.rv ),rvy ( K0.rvy ),rvu ( K0.rvu ),
-		dimx ( rv.count() ), dimy ( rvy.count() ),dimu ( rvu.count() ),
-		A ( dimx,dimx ), B ( dimx,dimu ), C ( dimy,dimx ), D ( dimy,dimu ),
-		Q(dimx), R(dimy),
-		est ( rv ), fy ( rvy ), _yp(fy._mu()),_Ry(fy._R()), _mu(est._mu()), _P(est._R()) {
-
-	this->set_parameters ( K0.A, K0.B, K0.C, K0.D, K0.R, K0.Q );
+Kalman<sq_T>::Kalman ( const Kalman<sq_T> &K0 ) : BM ( ),rvy ( K0.rvy ),rvu ( K0.rvu ),
+		dimx ( K0.dimx ), dimy ( K0.dimy ),dimu ( K0.dimu ),
+		A ( K0.A ), B ( K0.B ), C ( K0.C ), D ( K0.D ),
+		Q(K0.Q), R(K0.R),
+		est ( K0.est ), fy ( K0.fy ), _yp(fy._mu()),_Ry(fy._R()), _mu(est._mu()), _P(est._R()) {
 
 // copy values in pointers
-	_mu = K0._mu;
-	_P = K0._P;
-	_yp = K0._yp;
-	_Ry = K0._Ry;
+// 	_mu = K0._mu;
+// 	_P = K0._P;
+// 	_yp = K0._yp;
+// 	_Ry = K0._Ry;
 
 }
 
 template<class sq_T>
-Kalman<sq_T>::Kalman ( RV rvx, RV rvy0, RV rvu0 ) : BM ( rvx ),rvy ( rvy0 ),rvu ( rvu0 ),
-		dimx ( rvx.count() ), dimy ( rvy.count() ),dimu ( rvu.count() ),
-		A ( dimx,dimx ), B ( dimx,dimu ), C ( dimy,dimx ), D ( dimy,dimu ),
-		Q(dimx), R (dimy),
-		est ( rvx ), fy ( rvy ),  _yp(fy._mu()),_Ry(fy._R()),_mu(est._mu()), _P(est._R()) {
+Kalman<sq_T>::Kalman ( ) : BM (), est ( ), fy (),  _yp(fy._mu()), _Ry(fy._R()), _mu(est._mu()), _P(est._R()) {
 };
 
Index: /bdm/estim/libPF.cpp
===================================================================
--- /bdm/estim/libPF.cpp (revision 267)
+++ /bdm/estim/libPF.cpp (revision 270)
@@ -13,7 +13,7 @@
 	for ( i=0;i<n;i++ ) {
 		//generate new samples from paramater evolution model;
-		_samples ( i ) = par.samplecond ( _samples ( i ));
-		lls(i )= par._e()->evallog(_samples(i));
-		lls ( i ) *= obs.evallogcond ( dt,_samples ( i ) );
+		_samples ( i ) = par->samplecond ( _samples ( i ));
+		lls(i )= par->_e()->evallog(_samples(i));
+		lls ( i ) *= obs->evallogcond ( dt,_samples ( i ) );
 
 		if ( lls ( i ) >mlls ) mlls=lls ( i ); //find maximum
Index: /bdm/estim/mixef.h
===================================================================
--- /bdm/estim/mixef.h (revision 262)
+++ /bdm/estim/mixef.h (revision 270)
@@ -69,6 +69,6 @@
 	//! Full constructor
 	MixEF ( const Array<BMEF*> &Coms0, const vec &alpha0 ) :
-			BMEF ( RV() ), n ( Coms0.length() ), Coms ( n ),
-			weights ( RV ( "{w }", vec_1 ( n ) ),alpha0 ), method(QB) {
+			BMEF (  ), n ( Coms0.length() ), Coms ( n ),
+			weights (), method(QB) {
 	//	it_assert_debug ( n>0,"MixEF::MixEF : Empty Component list" );
 
@@ -78,8 +78,8 @@
 	//! Constructor of empty mixture
 	MixEF () :
-			BMEF ( RV() ), n ( 0 ), Coms ( 0 ),
-			weights ( RV ( "{w }", vec_1 ( 0 ) ),vec ( 0 ) ),method(QB) {build_est();}
+			BMEF ( ), n ( 0 ), Coms ( 0 ),
+			weights (),method(QB) {build_est();}
 	//! Copy constructor
-	MixEF(const MixEF &M2): BMEF ( RV() ), n ( M2.n ), Coms ( n ),
+	MixEF(const MixEF &M2): BMEF ( ), n ( M2.n ), Coms ( n ),
 		   weights ( M2.weights ), method(M2.method) {
 	//	it_assert_debug ( n>0,"MixEF::MixEF : Empty Component list" );
@@ -106,5 +106,5 @@
 	const epdf& _epdf() const {return *est;}
 	const eprod* _e() const {return est;}
-	emix* predictor(const RV &rv) const;
+	emix* epredictor() const;
 	//! Flatten the density as if it was not estimated from the data
 	void flatten(const BMEF* M2);
Index: /bdm/math/chmat.h
===================================================================
--- /bdm/math/chmat.h (revision 262)
+++ /bdm/math/chmat.h (revision 270)
@@ -48,4 +48,6 @@
 	//! Destructor for future use;
 	virtual ~chmat() {};
+	//!
+	chmat ( ) : sqmat (),Ch ( ) {};
 	//! Default constructor
 	chmat ( const int dim0 ) : sqmat ( dim0 ),Ch ( dim0,dim0 ) {};
Index: /bdm/math/libDC.h
===================================================================
--- /bdm/math/libDC.h (revision 262)
+++ /bdm/math/libDC.h (revision 270)
@@ -104,4 +104,6 @@
 		//! Default constructor
 		sqmat(const int dim0): dim(dim0){};
+		//! Default constructor
+		sqmat(): dim(0){};
 	protected:
 		//! dimension of the square matrix
@@ -131,5 +133,5 @@
 
 		//! Default initialization
-		fsqmat(); // mat will be initialized OK
+		fsqmat(){}; // mat will be initialized OK
 		//! Default initialization with proper size
 		fsqmat(const int dim0); // mat will be initialized OK
Index: /bdm/uibuilder.h
===================================================================
--- /bdm/uibuilder.h (revision 263)
+++ /bdm/uibuilder.h (revision 270)
@@ -78,7 +78,7 @@
 			return tmp;
 		};
-		const vec getivec ( Setting& S ) const {
+		const ivec getivec ( Setting& S ) const {
 			CHECK_UITYPE ( S,TypeArray );
-			vec tmp;
+			ivec tmp;
 			tmp.set_size ( S.getLength() );
 			for ( int i=0;i<S.getLength();i++ ) {
Index: /bdm/stat/libFN.h
===================================================================
--- /bdm/stat/libFN.h (revision 262)
+++ /bdm/stat/libFN.h (revision 270)
@@ -28,5 +28,5 @@
 		vec eval ( const vec &cond ) {return val;};
 		//!Default constructor
-		constfn ( const vec &val0 ) :fnc(val0.length()), val ( val0 ) {};
+		constfn ( const vec &val0 ) :fnc(), val ( val0 ) {dimy=val.length();};
 };
 
@@ -38,14 +38,14 @@
 		//! Matrix A
 		mat A;
-		//! Matrix B
+		//! vector B
 		vec B;
 	public :
-		vec eval (const vec &cond ) {it_assert_debug ( cond.length() ==rv.count(), "linfn::eval Wrong cond." );return A*cond+B;};
+		vec eval (const vec &cond ) {it_assert_debug ( cond.length() ==A.cols(), "linfn::eval Wrong cond." );return A*cond+B;};
 
 //		linfn evalsome ( ivec &rvind );
 		//!default constructor
-		linfn ( const RV &rv0 ) : fnc(rv0.count()), rv ( rv0 ),A ( eye ( rv0.count() ) ),B ( zeros ( rv0.count() ) ) { };
+		linfn ( ) : fnc(), A ( ),B () { };
 		//! Set values of \c A and \c B
-		void set_parameters ( const mat &A0 , const vec &B0 ) {A=A0; B=B0;};
+		void set_parameters ( const mat &A0 , const vec &B0 ) {A=A0; B=B0; dimy=A.rows();};
 };
 
@@ -86,5 +86,5 @@
 		virtual void dfdu_cond ( const vec &x0, const vec &u0, mat &A, bool full=true ) {};
 		//!Default constructor (dimy is not set!)
-		diffbifn (int dimy, const RV rvx0, const RV rvu0 ) : fnc(dimy), rvx ( rvx0 ),rvu ( rvu0 ) {dimx=rvx.count();dimu=rvu.count();};
+		diffbifn () : fnc() {};
 		//! access function
 		int _dimx() const{return dimx;}
@@ -100,11 +100,22 @@
 		mat B;
 	public :
+		//!\name Constructors
+		//!@{
+		
+		bilinfn () : diffbifn () ,A() ,B() 	{};
+		bilinfn (const mat A0, const mat B0) {set_parameters(A0,B0);};
+		//! Alternative constructor
+		void set_parameters(const mat A0, const mat B0){
+			it_assert_debug(A0.rows()==B0.rows(),"");
+			A=A0;B=B0;
+			dimy=A.rows();
+			dimx=A.cols();
+			dimu=B.cols();
+		}
+		//!@}
+		
+		//!\name Mathematical operations
+		//!@{
 		vec eval ( const  vec &x0, const vec &u0 );
-
-		//! Default constructor
-		bilinfn ( const RV &rvx0, const RV &rvu0 ) : diffbifn (dimx, rvx0,rvu0 ) ,A ( eye ( dimx ) ),B ( zeros ( dimx,dimu ) )	{};
-		//! Alternative constructor
-		bilinfn ( const RV &rvx0, const RV &rvu0, const mat &A0, const mat &B0 );
-		//!
 		void dfdx_cond ( const vec &x0, const vec &u0, mat &F, bool full )
 		{
@@ -118,4 +129,5 @@
 			if ( full ) F=B;	//else : nothing has changed no need to regenerate
 		}
+		//!@}
 };
 
Index: /bdm/stat/libEF.cpp
===================================================================
--- /bdm/stat/libEF.cpp (revision 262)
+++ /bdm/stat/libEF.cpp (revision 270)
@@ -22,7 +22,7 @@
 	int vend = val.length()-1;
 
-	if ( xdim==1 ) { //same as the following, just quicker.
+	if ( dimx==1 ) { //same as the following, just quicker.
 		double r = val ( vend ); //last entry!
-		vec Psi ( nPsi+xdim );
+		vec Psi ( nPsi+dimx );
 		Psi ( 0 ) = -1.0;
 		Psi.set_subvector ( 1,val ( 0,vend-1 ) ); // fill the rest
@@ -32,8 +32,8 @@
 	}
 	else {
-		mat Th= reshape ( val ( 0,nPsi*xdim-1 ),nPsi,xdim );
-		fsqmat R ( reshape ( val ( nPsi*xdim,vend ),xdim,xdim ) );
-		mat Tmp=concat_vertical ( -eye ( xdim ),Th );
-		fsqmat iR ( xdim );
+		mat Th= reshape ( val ( 0,nPsi*dimx-1 ),nPsi,dimx );
+		fsqmat R ( reshape ( val ( nPsi*dimx,vend ),dimx,dimx ) );
+		mat Tmp=concat_vertical ( -eye ( dimx ),Th );
+		fsqmat iR ( dimx );
 		R.inv ( iR );
 
@@ -45,5 +45,5 @@
 	const vec& D = V._D();
 
-	double m = nu - nPsi -xdim-1;
+	double m = nu - nPsi -dimx-1;
 #define	log2  0.693147180559945286226763983
 #define	logpi 1.144729885849400163877476189
@@ -51,11 +51,11 @@
 #define Inf std::numeric_limits<double>::infinity()
 
-	double nkG = 0.5* xdim* ( -nPsi *log2pi + sum ( log ( D ( xdim,D.length()-1 ) ) ) );
+	double nkG = 0.5* dimx* ( -nPsi *log2pi + sum ( log ( D ( dimx,D.length()-1 ) ) ) );
 	// temporary for lgamma in Wishart
 	double lg=0;
-	for ( int i =0; i<xdim;i++ ) {lg+=lgamma ( 0.5* ( m-i ) );}
-
-	double nkW = 0.5* ( m*sum ( log ( D ( 0,xdim-1 ) ) ) ) \
-	             - 0.5*xdim* ( m*log2 + 0.5* ( xdim-1 ) *log2pi )  - lg;
+	for ( int i =0; i<dimx;i++ ) {lg+=lgamma ( 0.5* ( m-i ) );}
+
+	double nkW = 0.5* ( m*sum ( log ( D ( 0,dimx-1 ) ) ) ) \
+	             - 0.5*dimx* ( m*log2 + 0.5* ( dimx-1 ) *log2pi )  - lg;
 
 	it_assert_debug ( ( ( -nkG-nkW ) >-Inf ) && ( ( -nkG-nkW ) <Inf ), "ARX improper" );
@@ -65,16 +65,16 @@
 vec egiw::mean() const {
 
-	if ( xdim==1 ) {
+	if ( dimx==1 ) {
 		const mat &L= V._L();
 		const vec &D= V._D();
 		int end = L.rows()-1;
 
-		vec m ( rv.count() );
-		mat iLsub = ltuinv ( L ( xdim,end,xdim,end ) );
+		vec m ( dim );
+		mat iLsub = ltuinv ( L ( dimx,end,dimx,end ) );
 
 		vec L0 = L.get_col ( 0 );
 
 		m.set_subvector ( 0,iLsub*L0 ( 1,end ) );
-		m ( end ) = D ( 0 ) / ( nu -nPsi -2*xdim -2 );
+		m ( end ) = D ( 0 ) / ( nu -nPsi -2*dimx -2 );
 		return m;
 	}
@@ -90,14 +90,14 @@
 vec egiw::variance() const {
 
-	if ( xdim==1 ) {
+	if ( dimx==1 ) {
 		int l=V.rows();
 		const ldmat tmp(V,linspace(1,l-1));
 		ldmat itmp(l);
 		tmp.inv(itmp);
-		double cove = V._D() ( 0 ) / ( nu -nPsi -2*xdim -2 );
+		double cove = V._D() ( 0 ) / ( nu -nPsi -2*dimx -2 );
 		
 		vec var(l);
 		var.set_subvector(0,diag(itmp.to_mat())*cove);
-		var(l-1)=cove*cove/( nu -nPsi -2*xdim -2 );
+		var(l-1)=cove*cove/( nu -nPsi -2*dimx -2 );
 		return var;
 	}
@@ -110,9 +110,9 @@
 	int end = L.rows()-1;
 
-	ldmat ldR ( L ( 0,xdim-1,0,xdim-1 ), D ( 0,xdim-1 ) / ( nu -nPsi -2*xdim -2 ) ); //exp val of R
-	mat iLsub=ltuinv ( L ( xdim,end,xdim,end ) );
+	ldmat ldR ( L ( 0,dimx-1,0,dimx-1 ), D ( 0,dimx-1 ) / ( nu -nPsi -2*dimx -2 ) ); //exp val of R
+	mat iLsub=ltuinv ( L ( dimx,end,dimx,end ) );
 
 	// set mean value
-	mat Lpsi = L ( xdim,end,0,xdim-1 );
+	mat Lpsi = L ( dimx,end,0,dimx-1 );
 	M= iLsub*Lpsi;
 	R= ldR.to_mat()  ;
@@ -120,8 +120,8 @@
 
 vec egamma::sample() const {
-	vec smp ( rv.count() );
+	vec smp ( dim);
 	int i;
 
-	for ( i=0; i<rv.count(); i++ ) {
+	for ( i=0; i<dim; i++ ) {
 		if ( beta ( i ) >std::numeric_limits<double>::epsilon() ) {
 			GamRNG.setup ( alpha ( i ),beta ( i ) );
@@ -156,5 +156,5 @@
 	int i;
 
-	for ( i=0; i<rv.count(); i++ ) {
+	for ( i=0; i<dim; i++ ) {
 		res += ( alpha ( i ) - 1 ) *std::log ( val ( i ) ) - beta ( i ) *val ( i );
 	}
@@ -168,5 +168,5 @@
 	int i;
 
-	for ( i=0; i<rv.count(); i++ ) {
+	for ( i=0; i<dim; i++ ) {
 		res += lgamma ( alpha ( i ) ) - alpha ( i ) *std::log ( beta ( i ) ) ;
 	}
@@ -176,8 +176,9 @@
 
 //MGamma
-void mgamma::set_parameters ( double k0 ) {
+void mgamma::set_parameters ( double k0, const vec &beta0 ) {
 	k=k0;
 	ep = &epdf;
-	epdf.set_parameters ( k*ones ( rv.count() ),*_beta );
+	epdf.set_parameters ( k*ones ( beta0.length()),beta0 );
+	dimc = ep->dimension();
 };
 
@@ -273,4 +274,5 @@
 	n=w.length();
 	samples.set_size ( n );
+	dim = epdf0->dimension();
 
 	for ( int i=0;i<n;i++ ) {samples ( i ) =epdf0->sample();}
